'Red Jumpy Ball
'By: Ryan
'Goofy game developed for Lachie's OneKey Challenge!
'Started on Nov.15, 2003
'Refurbished in FB on Apr.2, 2005

'Note: I have removed the cheat code from the source
'to prevent people from looking through here to turn
'it on themselves.  I have also removed the high score
'encryption routine for security purposes.

declare sub AnimateTiles ()
declare sub CompleteLevel ()
declare sub ExportScores ()
declare sub GameInit ()
declare sub GameLoop ()
declare sub GameMenu ()
declare sub GetBonus (bx%, by%)
declare sub Introduce (stage%)
declare sub LevelInit ()
declare sub LoadLevel ()
declare sub LoadScores (filename$)
declare sub LoadSettings ()
declare sub MarathonGame ()
declare sub PrintScores (gtype%)
declare sub RenderScreen ()
declare sub SaveScores ()
declare sub SaveSettings ()

declare function CanMove% (direction%)
declare function GetName$ (x%, y%)
declare function PlayAgain% ()
declare function TileType% (x%, y%)
declare function UseCredit% ()

'$include:'fbgfx.bi'

TYPE playertype
  gametype AS INTEGER
  onlevel AS INTEGER
  completed AS INTEGER
  lives AS INTEGER
  credits AS INTEGER
  points AS LONG
  startpoints AS LONG
  totalpoints as long
  time AS INTEGER
  x AS INTEGER
  y AS INTEGER
  offx AS INTEGER
  offy AS INTEGER
  state AS INTEGER
  vertvel AS INTEGER
  jumpmod AS INTEGER
  lasermod AS INTEGER
  speedmod AS INTEGER
  pointmod AS INTEGER
  translucent AS INTEGER
  frame AS INTEGER
  walkframes AS INTEGER
  jumpframe AS INTEGER
  jlength as integer
  llength as integer
  died as integer
  cheat as integer
END TYPE

TYPE maptype
  x AS INTEGER
  y AS INTEGER
  offx AS INTEGER
  offy AS INTEGER
  speed AS INTEGER
  onpage AS INTEGER
END TYPE

TYPE scoretype
  name AS STRING * 8
  score AS LONG
  stage as integer
END TYPE

TYPE scoretabletype
  classic(1 TO 10) AS scoretype
  onescreen(1 TO 10) AS scoretype
  keepitup(1 to 10) as scoretype
  timeattack(1 to 10) as scoretype
  marathon(1 to 10) as scoretype
END TYPE

TYPE screenrestype
  x AS INTEGER
  y AS INTEGER
END TYPE

TYPE tilestype
  x AS INTEGER
  y AS INTEGER
END TYPE

dim shared player AS playertype, map AS maptype, scoretable AS scoretabletype
dim shared scrres as screenrestype, tiles as tilestype
dim shared gamespeed as single, speeddiff as integer, fullscreen as integer, cheatmode as integer

REDIM SHARED level(0 to 1, 0 to 1) as integer
DIM SHARED grey1 AS LONG, grey2 AS LONG, white AS LONG, bar1 AS LONG
DIM SHARED bar2 AS LONG, bar3 AS LONG, laser1 AS LONG, laser2 AS LONG
DIM SHARED ball1(404), ball2(404), ball3(404), ball4(404), ball5(404)
DIM SHARED ground(404), brick(404), pole1(404), pole2(404), pole3(404)
dim shared lbank(404), water(404), rbank(404)
DIM SHARED sfline1(404), sfline2(404), sfline3(404), sflineb(404), credit(404)
DIM SHARED oneup(404), jboost(404), sboost(404), lboost(404), trans(404)
DIM SHARED clock(404), points(404), p100(404), p200(404), p300(404)
DIM SHARED p400(404), p500(404), ptimes2(404)
DIM SHARED wanim1(404), wanim2(404), wanim3(404), wanim4(404)
dim shared bground(243204), timeup(23044), lcomp(23044), fallen(23044)

CONST true = 1, false = 0, solidtyle = 50, bonustyle = 30
CONST walking = 1, jumping = 2, stuck = 3, gravity = 2, tvelocity = -10
CONST dir_up = 1, dir_right = 2, dir_down = 3, jump = 4, maxjlength = 25, maxllength = 50
CONST graphicsdir = "./graphics/", datadir = "./data/"
const game_classic = 1, game_onescreen = 2, game_keepitup = 3
const game_timeattack = 4, game_marathon = 5, game_scores = 6
const speed_test = -1
const max_time = 999, max_lives = 9, max_credits = 9

GameInit

do
  GameMenu
    select case player.gametype
      case speed_test, game_classic, game_onescreen, game_keepitup, game_timeattack
        do
          player.completed = false
          player.points = 0
          player.startpoints = 0
          player.lives = 3
          player.credits = 0
          LevelInit
          GameLoop
          pagain% = PlayAgain%
        loop until pagain% = false
      case game_marathon
        MarathonGame
      case game_scores
        FOR x = game_classic TO game_marathon
          cls
          PrintScores x
          screencopy
          DO: LOOP UNTIL Multikey(SC_SPACE): WHILE Multikey(SC_SPACE): WEND
        NEXT
    end select
loop

'-----------------------------------------------------------------
'Animates the tiles, right now the destroyed walls.

sub AnimateTiles ()
  
FOR x = map.x TO map.x + 32
FOR y = map.y TO UBOUND(Level, 2)
  SELECT CASE Level(x, y)
    CASE 70
      Level(x, y) = 71
    CASE 71
      Level(x, y) = 72
    CASE 72
      Level(x, y) = 73
    CASE 73
      Level(x, y) = 74
    CASE 74
      Level(x, y) = 0
  END SELECT
NEXT
NEXT

end sub

'-----------------------------------------------------------------
'Check for moving in a direction.

function CanMove% (direction%)

CanMove% = false
    
SELECT CASE direction%
  CASE dir_right
    moved% = 0
    DO
      moved% = moved% + 1
      tempx% = map.x * 10 + map.offx + player.x * 10 + player.offx + 9
      tempy1% = map.y * 10 + map.offy + player.y * 10 + player.offy
      tempy2% = map.y * 10 + map.offy + player.y * 10 + player.offy + 9
      IF tempy2% < 0 THEN moved% = map.speed + player.speedmod: EXIT DO
      IF player.translucent = 0 AND TileType%(tempx% + moved%, tempy1%) > solidtyle THEN moved% = moved% - 1: EXIT DO
      IF player.translucent = 0 AND TileType%(tempx% + moved%, tempy2%) > solidtyle THEN moved% = moved% - 1: EXIT DO
      GetBonus map.x * 10 + map.offx + player.x * 10 + player.offx + 9 + moved%, map.y * 10 + map.offy + player.y * 10 + player.offy
      GetBonus map.x * 10 + map.offx + player.x * 10 + player.offx + 9 + moved%, map.y * 10 + map.offy + player.y * 10 + player.offy + 9
    LOOP UNTIL moved% = ABS(map.speed + player.speedmod)
    CanMove% = moved%
  CASE dir_up
    moved% = 0
    IF player.vertvel > 0 THEN
      DO
        moved% = moved% + 1
        tempx1% = map.x * 10 + map.offx + player.x * 10 + player.offx
        tempx2% = tempx1% + 9
        tempy% = map.y * 10 + map.offy + player.y * 10 + player.offy
        IF player.translucent = 0 AND TileType%(tempx1%, tempy% - moved%) > solidtyle THEN moved% = moved% - 1: EXIT DO
        IF player.translucent = 0 AND TileType%(tempx2%, tempy% - moved%) > solidtyle THEN moved% = moved% - 1: EXIT DO
        GetBonus map.x * 10 + map.offx + player.x * 10 + player.offx + moved%, map.y * 10 + map.offy + player.y * 10 + player.offy
        GetBonus map.x * 10 + map.offx + player.x * 10 + player.offx + 9 + moved%, map.y * 10 + map.offy + player.y * 10 + player.offy
      LOOP UNTIL moved% = ABS(player.vertvel)
      END IF
    CanMove% = moved%
  CASE dir_down
    moved% = 0
    IF player.vertvel < 0 THEN
      DO
        moved% = moved% + 1
        tempx1% = map.x * 10 + map.offx + player.x * 10 + player.offx
        tempx2% = tempx1% + 9
        tempy% = map.y * 10 + map.offy + player.y * 10 + player.offy + 9
        IF TileType%(tempx1%, tempy% + moved%) > solidtyle THEN moved% = moved% - 1: EXIT DO
        IF TileType%(tempx2%, tempy% + moved%) > solidtyle THEN moved% = moved% - 1: EXIT DO
        GetBonus map.x * 10 + map.offx + player.x * 10 + player.offx + moved%, map.y * 10 + map.offy + player.y * 10 + player.offy + 9
        GetBonus map.x * 10 + map.offx + player.x * 10 + player.offx + 9 + moved%, map.y * 10 + map.offy + player.y * 10 + player.offy + 9
      LOOP UNTIL moved% = ABS(player.vertvel)
      END IF
    CanMove% = moved%
END SELECT
  
end function

'-----------------------------------------------------------------
'Completes the level/tallies the score.

sub CompleteLevel ()

dim ptimer as double
hbonus% = 0
tbonus% = 0

RenderScreen
put (100, 50), lcomp, trans
screencopy

DO: LOOP UNTIL MultiKey(SC_SPACE)
WHILE MultiKey(SC_SPACE): WEND

line (75,50)-(245,142), grey1, b
line (76,51)-(244,141), grey2, b
line (77,52)-(243,140), 0, bf

color white

if player.gametype = game_keepitup or player.gametype = game_timeattack and player.completed = false then
  locate 8, 12: print "Completion Bonuses": screencopy
  ptimer = timer: do: loop until timer - ptimer >= .5
  locate 10, 18: print "(None)": screencopy
  ptimer = timer: do: loop until timer - ptimer >= .5
  locate 12, 15: print "Score: " + str$(player.points): screencopy
  DO: LOOP UNTIL MultiKey(SC_SPACE)
  WHILE MultiKey(SC_SPACE): WEND
else

locate 8, 12: print  "Completion Bonuses"
screencopy
ptimer = timer: do: loop until timer - ptimer >= .5

hbonus% = (17 - player.y) * 100
IF hbonus% >= 1800 THEN
  locate 10, 14: print "Height: " + STR$(hbonus%) + " x4"
  hbonus% = hbonus% * 4
ELSEIF hbonus% >= 1200 THEN
  locate 10, 14: print "Height: " + STR$(hbonus%) + " x3"
  hbonus% = hbonus% * 3
ELSEIF hbonus% >= 600 THEN
  locate 10, 14: print "Height: " + STR$(hbonus%) + " x2"
  hbonus% = hbonus% * 2
ELSE
  locate 10, 14: print "Height: " + STR$(hbonus%)
END IF
screencopy
ptimer = timer: do: loop until timer - ptimer >= .5

if player.gametype = game_keepitup or player.gametype = game_timeattack then
  locate 12, 15: print "Score"
  locate 13, 15: print "  x2 : " + str$(player.points)
  screencopy
  ptimer = timer: do: loop until timer - ptimer >= .5
  tbonus% = player.points
else
  locate 12, 16: print "Time: " + STR$(player.time)
  locate 13, 15: print "Bonus: 0"
  screencopy
  ptimer = timer: do: loop until timer - ptimer >= .5
  tbonus% = 0: timeleft% = player.time
  if timeleft% > 0 then
   DO
     timeleft% = timeleft% - 1
     tbonus% = tbonus% + 15
     if player.gametype = game_timeattack and player.cheat = true then tbonus% = tbonus% + 235
     locate 12, 16: print "Time: " + STR$(timeleft%) + "  "
     locate 13, 15: print "Bonus: " + STR$(tbonus%)
     screencopy
     ptimer = timer: do: loop until timer - ptimer >= .01
   LOOP UNTIL timeleft% <= 0
  end if
  ptimer = timer: do: loop until timer - ptimer >= .5
end if
if player.gametype = game_timeattack and player.cheat = true then
  locate 14, 16: print "Time: " + str$(player.time * 250)
  screencopy
  ptimer = timer: do: loop until timer - ptimer >= .01
  tbonus% = tbonus% + player.time * 250
end if
locate 15, 15: print "Total: " + STR$(hbonus% + tbonus%)
screencopy
ptimer = timer: do: loop until timer - ptimer >= .5


player.points = player.points + hbonus% + tbonus%
locate 17, 15: print "Score: " + STR$(player.points)
screencopy
DO: LOOP UNTIL MultiKey(SC_SPACE)
WHILE MultiKey(SC_SPACE): WEND

if player.gametype = game_Marathon then
  line (75,50)-(245,142), grey1, b
  line (76,51)-(244,141), grey2, b
  line (77,52)-(243,140), 0, bf
  color white
  if player.onlevel < 8 then
    locate 8, 14: print "Status so far:"
  else
    locate 8, 15: print "Final Score:"
  end if
  screencopy
  ptimer = timer: do: loop until timer - ptimer >= .5
  locate 10, 12: print "Previous: " + str$(player.totalpoints)
  screencopy
  ptimer = timer: do: loop until timer - ptimer >= .5
  y = 12
  if player.startpoints >= 4000 then
    if player.cheat = true then player.startpoints = player.startpoints * 4
    locate y, 13: print "Drop In:+" + str$(player.startpoints)
    player.totalpoints = player.totalpoints + player.startpoints
    screencopy
    ptimer = timer: do: loop until timer - ptimer >= .5
    y = y + 1
  end if
  if player.died = false then
    locate y, 12: print "No Death:+" + str$(player.onlevel * 1000)
    player.totalpoints = player.totalpoints + player.onlevel * 1000
    screencopy
    ptimer = timer: do: loop until timer - ptimer >= .5
    y = y + 1
  end if
  if player.died = false and player.onlevel = 8 then
    locate y, 13: print "PERFECT:+50000"
    player.totalpoints = player.totalpoints + 50000
    screencopy
    ptimer = timer: do: loop until timer - ptimer >= .5
    y = y + 1
  end if
  locate y, 13: print "Stage " + str$(player.onlevel) + ":+" + str$(player.points)
  screencopy
  ptimer = timer: do: loop until timer - ptimer >= .5
  y = y + 2
  player.totalpoints = player.totalpoints + player.points
  locate y, 15: print "Total: " + str$(player.totalpoints)
  screencopy
  DO: LOOP UNTIL MultiKey(SC_SPACE)
  WHILE MultiKey(SC_SPACE): WEND
end if

end if  'From the Keep It Up if statement

SELECT CASE player.gametype
  CASE game_classic
    x = 0
    DO
      x = x + 1
      IF player.points > scoretable.classic(x).score THEN
        line (75,50)-(245,142), grey1, b
        line (76,51)-(244,141), grey2, b
        line (77,52)-(243,140), 0, bf
        color white
        locate 8, 14: print "New High Score!" 
        locate 10, 19: print str$(player.points)
        locate 12, 14: print "Name: "
        screencopy
        pname$ = GetName$(20, 12)
        if pname$ = "" then pname$ = "YourMom"
        IF x < 10 THEN
          FOR z = 9 TO x STEP -1
            scoretable.classic(z + 1).name = scoretable.classic(z).name
            scoretable.classic(z + 1).score = scoretable.classic(z).score
          NEXT
        END IF
        scoretable.classic(x).name = pname$
        scoretable.classic(x).score = player.points
        EXIT DO
      END IF
    LOOP UNTIL x = 10
  CASE game_onescreen
    x = 0
    DO
      x = x + 1
      IF player.points > scoretable.onescreen(x).score THEN
        line (75,50)-(245,142), grey1, b
        line (76,51)-(244,141), grey2, b
        line (77,52)-(243,140), 0, bf
        color white
        locate 8, 14: print "New High Score!" 
        locate 10, 19: print str$(player.points)
        locate 12, 14: print "Name: "
        screencopy
        pname$ = GetName$(20, 12)
        if pname$ = "" then pname$ = "YourMom"
        IF x < 10 THEN
          FOR z = 9 TO x STEP -1
            scoretable.onescreen(z + 1).name = scoretable.onescreen(z).name
            scoretable.onescreen(z + 1).score = scoretable.onescreen(z).score
          NEXT
        END IF
        scoretable.onescreen(x).name = pname$
        scoretable.onescreen(x).score = player.points
        EXIT DO
      END IF
    LOOP UNTIL x = 10
  case game_keepitup
    x = 0
    DO
      x = x + 1
      IF player.points > scoretable.keepitup(x).score THEN
        line (75,50)-(245,142), grey1, b
        line (76,51)-(244,141), grey2, b
        line (77,52)-(243,140), 0, bf
        color white
        locate 8, 14: print "New High Score!" 
        locate 10, 19: print str$(player.points)
        locate 12, 14: print "Name: "
        screencopy
        pname$ = GetName$(20, 12)
        if pname$ = "" then pname$ = "YourMom"
        IF x < 10 THEN
          FOR z = 9 TO x STEP -1
            scoretable.keepitup(z + 1).name = scoretable.keepitup(z).name
            scoretable.keepitup(z + 1).score = scoretable.keepitup(z).score
          NEXT
        END IF
        scoretable.keepitup(x).name = pname$
        scoretable.keepitup(x).score = player.points
        EXIT DO
      END IF
    LOOP UNTIL x = 10
  case game_timeattack
    x = 0
    DO
      x = x + 1
      IF player.points > scoretable.timeattack(x).score THEN
        line (75,50)-(245,142), grey1, b
        line (76,51)-(244,141), grey2, b
        line (77,52)-(243,140), 0, bf
        color white
        locate 8, 14: print "New High Score!" 
        locate 10, 19: print str$(player.points)
        locate 12, 14: print "Name: "
        screencopy
        pname$ = GetName$(20, 12)
        if pname$ = "" then pname$ = "YourMom"
        IF x < 10 THEN
          FOR z = 9 TO x STEP -1
            scoretable.timeattack(z + 1).name = scoretable.timeattack(z).name
            scoretable.timeattack(z + 1).score = scoretable.timeattack(z).score
          NEXT
        END IF
        scoretable.timeattack(x).name = pname$
        scoretable.timeattack(x).score = player.points
        EXIT DO
      END IF
    LOOP UNTIL x = 10
END SELECT

if player.gametype > speed_test and player.gametype < game_marathon then
  cls
  PrintScores player.gametype
  screencopy
  SaveScores
  do: loop until MultiKey(SC_SPACE)
  while MultiKey(SC_SPACE): wend
end if
 
end sub

'-----------------------------------------------------------------
'Exports the high score tables.

sub ExportScores()

'Removed to prevent hacking!

end sub

'-----------------------------------------------------------------
'Sets the screen resolution/initial vars, loads graphics/scores.

sub GameInit ()

LoadSettings

randomize timer

screenres 320, 200, 16, 2, fullscreen
screenset 1, 0
setmouse ,,0

player.walkframes = 6
player.jumpframe = 7
player.onlevel = 1
player.lives = 3
player.credits = 0
player.cheat = false

cls
bload graphicsdir + "palette.bmp", 0
grey1 = POINT(0, 0)
grey2 = POINT(1, 0)
white = POINT(2, 0)
bar1 = POINT(3, 0)
bar2 = POINT(4, 0)
bar3 = POINT(5, 0)
laser1 = POINT(6, 0)
laser2 = POINT(7, 0)

cls
bload graphicsdir + "graphics.bmp", 0
get (0, 0)-(9, 9), ball1
get (10, 0)-(19, 9), ball2
get (20, 0)-(29, 9), ball3
get (30, 0)-(39, 9), ball4
get (40, 0)-(49, 9), ball5
get (0, 10)-(9, 19), ground
get (10, 10)-(19, 19), brick
get (20, 10)-(29, 19), lbank
get (30, 10)-(39, 19), water
get (40, 10)-(49, 19), rbank
get (0, 20)-(9, 29), pole1
get (10, 20)-(19, 29), pole2
get (20, 20)-(29, 29), pole3
get (30, 20)-(39, 29), clock
get (40, 20)-(49, 29), points
get (0, 30)-(9, 39), sfline1
get (10, 30)-(19, 39), sfline2
get (20, 30)-(29, 39), sfline3
get (30, 30)-(39, 39), sflineb
get (40, 30)-(49, 39), credit
get (0, 40)-(9, 49), oneup
get (10, 40)-(19, 49), jboost
get (20, 40)-(29, 49), sboost
get (30, 40)-(39, 49), lboost
get (40, 40)-(49, 49), trans
get (0, 50)-(9, 59), wanim1
get (10, 50)-(19, 59), wanim2
get (20, 50)-(29, 59), wanim3
get (30, 50)-(39, 59), wanim4
get (40, 50)-(49, 59), ptimes2
get (0, 60)-(9, 69), p500
get (10, 60)-(19, 69), p400
get (20, 60)-(29, 69), p300
get (30, 60)-(39, 69), p200
get (40, 60)-(49, 69), p100

bload graphicsdir + "timeup.bmp", varptr(timeup(0))
bload graphicsdir + "lcomp.bmp", varptr(lcomp(0))
bload graphicsdir + "fallen.bmp", varptr(fallen(0))

LoadScores "scores.dat"

end sub

'-----------------------------------------------------------------
'Plays the game!
sub GameLoop()

dim ptime as double, atimer as double, gtimer as double, mtimer as double, ttimer as double

RenderScreen
screencopy
DO: LOOP UNTIL MultiKey(SC_SPACE)
while MultiKey(SC_SPACE): wend
  
ptime = timer
atimer = timer
gtimer = timer
mtimer = timer
ttimer = timer

dojump% = 0

DO
  'Translucency timer
  if timer - ttimer >= .25 * gamespeed then
    IF player.translucent > 0 THEN 
      if player.gametype = game_classic then
        if player.cheat = false then player.translucent = player.translucent - 1
      else
        player.translucent = player.translucent - 1
      end if
    end if
    ttimer = timer
  end if

  'Frame rotation
  if timer - atimer >= .07 * gamespeed then
    AnimateTiles
    IF player.state = walking THEN
      player.frame = player.frame + 1
      IF player.frame > player.walkframes THEN player.frame = 1
    ELSEIF player.state = jumping THEN
      IF player.frame < player.jumpframe THEN player.frame = player.frame + 1
    END IF
    atimer = timer
    RenderScreen
    screencopy
  END IF

  'Gravity
  if timer - gtimer >= .1 then
    player.vertvel = player.vertvel - gravity
    IF player.vertvel < tvelocity THEN player.vertvel = tvelocity
    gtimer = timer
    IF dojump% = 2 THEN
      player.vertvel = player.vertvel + jump + player.jlength / 5 + player.jumpmod
      player.jlength = 0: player.llength = 0
      player.state = jumping
      dojump% = 0
    END IF
  END IF

  'Moving the ball
  if timer - mtimer >= .02 * gamespeed then

    'If holding up arrow:
    IF MultiKey(SC_UP) AND dojump% > 0 THEN
      IF player.state <> stuck THEN player.jlength = player.jlength + 2 + speeddiff ELSE player.jlength = player.jlength + 2 + speeddiff
      IF player.jlength > maxjlength THEN player.jlength = maxjlength
      IF player.jlength = maxjlength AND CanMove%(dir_right) = 0 THEN
        player.llength = player.llength + 1 + player.lasermod + speeddiff
        IF player.llength > maxllength THEN player.llength = maxllength
      END IF
    END IF
    
    'If dropping:
    IF player.vertvel < 0 THEN
      IF player.vertvel < -10 THEN player.vertvel = -10
      move% = CanMove%(dir_down)
      IF move% > 0 THEN
        player.offy = player.offy + move%
        IF player.offy >= 10 THEN
          DO
            player.offy = player.offy - 10
            player.y = player.y + 1
            IF player.y = 17 THEN
              player.pointmod = 1
              if player.gametype = game_keepitup then
                player.completed = false
                CompleteLevel
                exit sub
              end if
              IF player.startpoints = 0 THEN player.startpoints = player.points
            END IF
            if player.y > 18 then
              player.died = true
              player.lives = player.lives - 1
              put (100,50), fallen, trans
              screencopy
              DO: LOOP UNTIL MultiKey(SC_SPACE)
              WHILE MultiKey(SC_SPACE): WEND
              exit sub
            end if
          LOOP UNTIL player.offy < 10
        END IF
      ELSE
        player.vertvel = 0
        player.state = walking
      END IF

    'If jumping:
    ELSEIF player.vertvel > 0 THEN
      move% = CanMove%(dir_up)
      IF move% > 0 THEN
        player.offy = player.offy - move%
        IF player.offy < 0 THEN
          DO
            player.offy = player.offy + 10
            player.y = player.y - 1
          LOOP UNTIL player.offy >= 0
        END IF
      ELSE
        player.vertvel = 0
      END IF
    END IF

    'Down the path:
    if player.gametype = game_keepitup and player.cheat = true and not MultiKey(SC_SPACE) then
    
    else
      IF map.x + 32 < UBOUND(Level, 1) THEN
        moved% = CanMove%(dir_right)
        map.offx = map.offx + moved%
        IF moved% > 0 THEN player.points = player.points + ((18 - player.y) * (map.speed - 1)) * player.pointmod
        IF map.offx >= 10 THEN
          map.x = map.x + 1
          map.offx = map.offx - 10
          IF map.x + 32 = UBOUND(Level, 1) THEN
            player.offx = player.offx + map.offx
            map.offx = 0
          END IF
        END IF
      ELSE
        moved% = CanMove%(dir_right)
        player.offx = player.offx + moved%
        if player.y < 0 then
          IF moved% > 0 THEN player.points = player.points + ((moved% * (18 - player.y) * (map.speed + player.speedmod - 1))) * player.pointmod
        else
          IF moved% > 0 THEN player.points = player.points + ((moved% * (18 - player.y) * (map.speed + player.speedmod - 1))) * 2 * player.pointmod
        end if
        IF player.offx >= 10 THEN
          player.x = player.x + 1
          player.offx = player.offx - 10
          IF player.x >= 30 THEN
            player.completed = true
            CompleteLevel
            EXIT DO
          END IF
        END IF
      END IF
    end if
    mtimer = timer

    RenderScreen
    screencopy
  END IF

  'If holding up
  IF MultiKey(SC_UP) * gamespeed THEN
    IF player.state <> jumping AND dojump% = 0 THEN dojump% = 1: player.jlength = 0
  ELSE
    IF dojump% = 1 AND player.llength < maxllength THEN dojump% = 2
    IF dojump% = 1 AND player.llength = maxllength THEN
      player.jlength = 0: player.llength = 0: dojump% = 0
      Level(map.x + player.x + 1, player.y) = 71
    END IF
  END IF

  'Count down the clock
  IF timer - ptime >= .22 and player.gametype <> game_keepitup THEN
    player.time = player.time - 1: ptime = timer
    IF player.time < 0 THEN
      player.time = 0
      if player.gametype = game_timeattack then
        player.completed = false
        CompleteLevel
        exit do
      end if
      player.died = true
      put (100,50), timeup, trans
      screencopy
      DO: LOOP UNTIL MultiKey(SC_SPACE)
      WHILE MultiKey(SC_SPACE): WEND
      player.lives = player.lives - 1
      EXIT DO
    END IF
  END IF

  if MultiKey(SC_ESCAPE) then
    player.lives = -1
    while MultiKey(SC_ESCAPE): wend
    exit do
  end if

  'RenderScreen
  'screencopy
LOOP

end sub

'-----------------------------------------------------------------
'Used to choose game mode/view high scores

sub GameMenu ()

cls
print "Red Jumpy Ball"
print "   By: Ryan"
print ""
print " Classic     "
print " One Screen  "
print " Keep It Up  "
print " Time Attack "
print " Marathon    "
print " High Scores"
print ""
print "(Esc to Quit)"
if cheatmode = true then
  locate 20, 1: print "Press C to toggle cheat mode: ";
  if player.cheat = true then 
    print "On "
    locate 4, 14: print "(Unending translucent)"
    locate 5, 14: print "(Start with x4 bonus)"
    locate 6, 14: print "(Move with space bar)"
    locate 7, 14: print "(Time * 250 end bonus)"
    locate 8, 14: print "(Drop in bonus x4)"
  else 
    print "Off"
  end if
end if
locate 21, 1: print "Press F to toggle full screen."
locate 22, 1: print "Press X to export the high scores."
locate 23, 1: print "Press R to reset the high scores."
locate 24, 1: print "Press S to test/adjust gamespeed.";

choice% = 1
locate choice% + 3, 1: print ">"
screencopy

DO
  if MultiKey(SC_X) then
    while MultiKey(SC_X): wend
    ExportScores
    locate 13, 1: print "Scores exported to ./data/scores.enc"
    screencopy
  end if
  
  if MultiKey(SC_S) then
    while MultiKey(SC_S): wend
    choice% = -1
    exit do
  end if
  
  if MultiKey(SC_C) and cheatmode = true then
    while MultiKey(SC_C): wend
    player.cheat = player.cheat xor 1
    locate 20, 1: print "Press C to toggle cheat mode: ";
    if player.cheat = true then 
      print "On "
      locate 4, 14: print "(Unending translucent)"
      locate 5, 14: print "(Start with x4 bonus)"
      locate 6, 14: print "(Move with space bar)"
      locate 7, 14: print "(Time * 250 end bonus)"
      locate 8, 14: print "(Drop in bonus x4)"
    else 
      print "Off"
      for y = 4 to 8
        locate y, 14: print space$(22)
      next
    end if
    screencopy
  end if
  
  if MultiKey(SC_R) then
    while MultiKey(SC_R): wend
    locate 13, 1: print "Are you sure? (Y/N)                 "
    screencopy
    do
      if MultiKey(SC_Y) then
        while MultiKey(SC_Y): wend
        locate 13, 1: print "You reset the high score tables.    "
        exit do
      end if
      if MultiKey(SC_N) then
        while MultiKey(SC_N): wend
        locate 13, 1: print "High score tables not reset.        "
        exit do
      end if
    loop
    screencopy
    LoadScores "scores.org"
    SaveScores
  end if

  if MultiKey(SC_F) then
    while MultiKey(SC_F): wend
    fullscreen = fullscreen xor 1
    screenres 320, 200, 16, 2, fullscreen
    screenset 1, 0
    setmouse ,,0
    cls
    print "Red Jumpy Ball"
    print "   By: Ryan"
    print ""
    print " Classic"
    print " One Screen"
    print " Keep It Up"
    print " Time Attack"
    print " Marathon"
    print " High Scores"
    print ""
    print "(Esc to Quit)"
    if cheatmode = true then
      locate 20, 1: print "Press C to toggle cheat mode: ";
      if player.cheat = true then 
        print "On "
        locate 4, 14: print "(Unending translucent)"
        locate 5, 14: print "(Start with x4 bonus)"
        locate 6, 14: print "(Move with space bar)"
        locate 7, 14: print "()"
        locate 8, 14: print "(Drop in bonus x4)"
      else 
        print "Off"
      end if
    end if
    locate 21, 1: print "Press F to toggle full screen."
    locate 22, 1: print "Press X to export the high scores."
    locate 23, 1: print "Press R to reset the high scores."
    locate 24, 1: print "Press S to test/adjust gamespeed.";
    locate choice% + 3, 1: print ">"
    screencopy
    SaveSettings
  end if
    
  IF MultiKey(SC_UP) THEN
    WHILE MultiKey(SC_UP): WEND
    locate choice% + 3, 1: print " "
    choice% = choice% - 1: IF choice% = 0 THEN choice% = 6
    locate choice% + 3, 1: print ">"
    screencopy
  END IF

  IF MultiKey(SC_DOWN) THEN
    WHILE MultiKey(SC_DOWN): WEND
    locate choice% + 3, 1: print " "
    choice% = choice% + 1: IF choice% = 7 THEN choice% = 1
    locate choice% + 3, 1: print ">"
    screencopy
  END IF
  
  if MultiKey(SC_ESCAPE) then
    cls
    screencopy
    end 0
  end if
   
LOOP UNTIL MultiKey(SC_ENTER) or MultiKey(SC_SPACE)
while MultiKey(SC_ENTER) or MultiKey(SC_SPACE): wend

player.gametype = choice%

end sub

'-----------------------------------------------------------------
'Gives the player a bonus!
sub GetBonus (bx%, by%)

tbx% = bx%: tby% = by%
b% = 0
DO
  b% = b% + 1
  SELECT CASE b%
    CASE 1
      bonus% = TileType%(bx%, by%)
    CASE 2
      bonus% = TileType%(bx% + 9, by%)
    CASE 3
      bonus% = TileType%(bx%, by% + 9)
    CASE 4
      bonus% = TileType%(bx% + 9, by% + 9)
  END SELECT
  IF bonus% >= bonustyle AND bonus% < solidtyle THEN
    SELECT CASE bonus%
      CASE 30
        player.credits = player.credits + 1
        if player.credits > max_credits then player.credits = max_credits
        player.points = player.points + (500 * player.pointmod)
        btile% = 25
      CASE 31
        player.lives = player.lives + 1
        if player.lives > max_lives then player.lives = max_lives
        player.points = player.points + (400 * player.pointmod)
        btile% = 23
      CASE 32
        player.jumpmod = player.jumpmod + 1
        IF player.jumpmod > 2 THEN player.jumpmod = 2
        player.points = player.points + (100 * player.pointmod)
        btile% = 21
      CASE 33
        player.speedmod = player.speedmod + 1
        IF player.speedmod > 2 THEN player.speedmod = 2
        player.points = player.points + (200 * player.pointmod)
        btile% = 22
      CASE 34
        player.lasermod = player.lasermod + 1
        IF player.lasermod > 2 THEN player.lasermod = 2
        player.points = player.points + (200 * player.pointmod)
        btile% = 22
      CASE 35
        player.translucent = player.translucent + 20
        IF player.translucent > 20 THEN player.translucent = 20
        player.points = player.points + (400 * player.pointmod)
        btile% = 24
      CASE 36 TO 40
        player.points = player.points + (((bonus% - 35) * 100) * player.pointmod)
        btile% = bonus% - 15
      CASE 41
        player.pointmod = player.pointmod * 2
        player.points = player.points + (500 * player.pointmod)
        btile% = 25
      CASE 42
        player.time = player.time + 15
        if player.time > max_time then player.time = max_time
        player.points = player.points + (300 * player.pointmod)
        btile% = 23
    END SELECT
    tilex% = 0: tiley% = 0
    DO
      tbx% = tbx% - 10
      tilex% = tilex% + 1
    LOOP UNTIL tbx% < 10
    DO
      tby% = tby% - 10
      tiley% = tiley% + 1
    LOOP UNTIL tby% < 10
    Level(tilex%, tiley%) = btile%
  END IF
LOOP UNTIL b% = 4
  
end sub

'-----------------------------------------------------------------
'Get the player's name for the high score!

function GetName$(x%, y%)
  
GetName$ = ""
temp$ = ""
char% = 0
color white
locate y%, x%: print "_"
screencopy
while inkey$ <> "": wend
DO
  SLEEP
  a$ = INKEY$
  if asc(ucase$(a$)) >= 65 and asc(ucase$(a$)) <= 90 and len(temp$) < 8 then
      temp$ = temp$ + a$
      locate y%, x%: print temp$ + "_"
      screencopy
  end if
  IF asc(a$) = 8 AND LEN(temp$) > 0 THEN
    temp$ = LEFT$(temp$, LEN(temp$) - 1)
    locate y%, x%: print temp$ + "_ "
    screencopy
  END IF
LOOP UNTIL a$ = CHR$(13)

if temp$ = "" then temp$ = "YourMom"
if player.cheat = true then
  if len(temp$) < 8 then temp$ = temp$ + "*" else temp$ = left$(temp$, 7) + "*"
end if

GetName$ = temp$

while MultiKey(SC_ENTER): wend
  
end function

'-----------------------------------------------------------------
'Introduce a Marathon stage

sub Introduce (stage%)

cls

select case stage%
  case 1
    print "Stage 1: Riobamba": print ""
    print "  The first leg of the Marathon winds"
    print "its way through the streets of Riobamba,";
    print "a quaint city surrounded by peaks and"
    print "volcanoes.  You'll want to set a nice"
    print "pace for yourself, and it's best not to"
    print "stop on the corner for some fried cow"
    print "gut.  It gives jumpy balls gas."
  case 2
    print "Stage 2: Riobamba Escape": print ""
    print "  Oh no!  The volcano has blown its top.";
    print "Your best bet is to haul it on out of"
    print "town.  You better pick up the pace on"
    print "this leg and get out fast to avoid the"
    print "soon coming debris."
  case 3
    print "Stage 3: Down the Road": print ""
    print "  Whew, you made it out safely.  Now"
    print "you're in for the longest leg of the"
    print "Marathon, the endurance section.  You"
    print "must travel from Riobamba down to the"
    print "town of Guamote, a market center for"
    print "several outlying villages.  Better set"
    print "a good pace but keep an eye on the"
    print "clock!"
  case 4
    print "Stage 4: Guamote": print ""
    print "  Guamote it is!  The town is fairly"
    print "quiet, but this stage of your journey"
    print "won't be.  The streets are all brick"
    print "and the course winds its way through"
    print "them like nobody's business.  You may"
    print "find the going a little tough, so make"
    print "sure you don't run out of time."
  case 5
    print "Stage 5: San Bernardo": print ""
    print "  Ahh, what a nice place to stop for a"
    print "rest.  The valley is so peaceful... but"
    print "the race stops for no paradise.  It's up";
    print "and at 'em.  You need to make it to the"
    print "other side of the pass before you can"
    print "turn in for the day.  Night is fast"
    print "approaching, and you'll need what's left";
    print "of the light to navigate those hills."
    print "This leg's a race against a low clock!";
  case 6
    print "Stage 6: San Bernardo": print ""
    print "  Still in the valley, you're now on a"
    print "path down by the creek.  Apparently, all";
    print "the villagers came out to cheer on the"
    print "contenders, bringing with them plenty of";
    print "point bags they're itching to throw out!";
    print "Don't be too distracted by the freebies,";
    print "though, or you'll bounce right into the"
    print "creek.  Red jumpy balls just can't cut"
    print "it in the water."
  case 7
    print "Stage 7: Up the Mountain": print ""
    print "  You're almost finished with the race,"
    print "but not finished enough to avoid this"
    print "uphill leg.  It will be impossible to"
    print "gain speed heading up the mountain,"
    print "and you'll need to make good time if you";
    print "expect to turn in a decent time."
  case 8
    print "Stage 8: Chausan San Alfonzo": print ""
    print "  The end is here!  The final pole is in";
    print "sight, but the road is risky.  This leg"
    print "of the course runs along the cliff of"
    print "a mountain's peak, and the ground is a"
    print "long way down.  So, build up your nerve"
    print "and bounce away!  Just know that a fall"
    print "means certain death..."
end select

screencopy
do: loop until MultiKey(SC_SPACE)
while MultiKey(SC_SPACE): wend
    
end sub


'-----------------------------------------------------------------
'Inits the level for play!

sub LevelInit ()
        
player.state = walking
player.frame = 1
player.jumpmod = 0
player.lasermod = 0
player.speedmod = 0
player.pointmod = 2
player.translucent = 0
player.offx = 0
player.offy = 0
player.vertvel = 0
player.jlength = 0
player.llength = 0

map.x = 0
map.y = 0
map.offx = 0
map.offy = 0
map.speed = 2
map.onpage = 1

LoadLevel

end sub

'-----------------------------------------------------------------
'Set up a level's map data.

sub LoadLevel ()

credits% = 1
oneups% = 3
clocks% = 4
jumps% = 6
pbag100% = 5
pbag200% = 4
pbag300% = 3
pbag400% = 2
pbag500% = 1
times2% = 4
speeds% = 4
lasers% = 6
transb% = 3
waterhaz% = 0

SELECT CASE player.gametype
  case speed_test
    player.onlevel = 1
    xmod% = 1
    bricks% = 0
    player.time = 50
    player.x = 1
    player.y = 17
    speeds% = 0
    clocks% = 0
    times2% = 20
    transb% = 10
  CASE game_classic
    player.onlevel = 1
    xmod% = 10
    bricks% = 750
    player.time = 250
    player.x = 5
    player.y = 5
    if player.cheat = true then player.translucent = 20
  CASE game_onescreen
    player.onlevel = 1
    xmod% = 1
    bricks% = 75
    player.time = 50
    player.x = 1
    player.y = 1
    if player.cheat = true then player.pointmod = 4
  case game_keepitup
    player.onlevel = 1
    xmod% = 10
    bricks% = 1500
    player.time = 999
    player.x = 5
    player.y = 1
  case game_timeattack
    player.onlevel = 1
    xmod% = 10
    bricks% = 750
    player.time = 25
    player.x = 5
    player.y = 5
  case game_marathon
    player.x = 5
    player.y = 5
    select case player.onlevel
      case 1
        xmod% = 10
        bricks% = 750
        map.speed = 2
        player.time = 250
      case 2
        xmod% = 15
        bricks% = 750
        map.speed = 4
        player.time = 175
        clocks% = 0
        lasers% = 3
        speeds% = 3
        pbag200% = 5
        pbag300% = 4
        pbag400% = 3
        pbag500% = 2
      case 3
        xmod% = 25
        bricks% = 1875
        map.speed = 2
        player.time = 525
        pbag100% = 10
        pbag200% = 10
        pbag300% = 8
        pbag400% = 6
        pbag500% = 3
      case 4
        xmod% = 10
        bricks% = 1000
        map.speed = 2
        player.time = 250
        lasers% = 8
        speeds% = 2
        transb% = 2
      case 5
        xmod% = 10
        bricks% = 750
        map.speed = 2
        player.time = 25
      case 6
        xmod% = 15
        bricks% = 1125
        map.speed = 2
        player.time = 300
        pbag100% = 15
        pbag200% = 13
        pbag300% = 11
        pbag400% = 9
        pbag500% = 7
        waterhaz% = 6
        clocks% = 6
      case 7
        xmod% = 15
        bricks% = 1000
        map.speed = 2
        player.time = 275
        speeds% = 0
        clocks% = 20
      case 8
        xmod% = 5
        bricks% = 1000
        map.speed = 2
        player.time = 200
        player.x = 5
        player.y = 1
        transb% = 4
    end select
END SELECT

if speeddiff = true and player.gametype > speed_test then player.time = player.time * 1.1

if player.gametype = game_marathon then
  backg% = player.onlevel  
else
  backg% = int(rnd*8) + 1
end if
bgfile$ = graphicsdir + "bground" + str$(backg%) + ".bmp"
bload bgfile$, varptr(bground(0))


REDIM Level(0 TO 32 * xmod%, 0 TO 19) as integer

'Set the Ground
if player.onlevel < 8 then
FOR x = 0 TO UBOUND(Level, 1)
  Level(x, UBOUND(Level, 2) - 1) = 51
NEXT
end if

'Set the Bricks
FOR z = 1 TO bricks%
  x = INT(RND * UBOUND(Level, 1))
  y = INT(RND * (UBOUND(Level, 2) - 1))
  Level(x, y) = 52
NEXT

'Set water hazards if called for
if waterhaz% > 0 then
  for z = 1 to waterhaz%
    i% = 0
    minx% = player.x + 11
    do
      i% = i% + 1
      goodspot% = true
      maxx% = ubound(Level, 1) - 10 - hazlen%
      leftbank% = int(rnd*(maxx% - minx%)) + minx%
      for z2 = leftbank% - 9 to leftbank% + 13
        if Level(z2, 18) > 10 and Level(z2, 18) < 14 then goodspot% = false
      next
      if i% > 1000 then exit for
    loop until goodspot% = true
    Level(leftbank%, 18) = 11
    for z2 = leftbank% + 1 to leftbank% + 2
      Level(z2, 18) = 12  
    next
    Level(leftbank% + 3, 18) = 13
  next
end if

'Set a Credit
if credits% > 0 then
for z = 1 to credits%
DO
  x = INT(RND * (UBOUND(Level, 1) - 25)) + 20
  y = INT(RND * (UBOUND(Level, 2) - 15)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 30
next
end if

'Set some 1 UPs
if oneups% > 0 then
FOR z = 1 TO oneups%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 15)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 31
NEXT
end if

'Set some Time Bonuses
if player.gametype = game_timeattack or player.onlevel = 5 then
  for sc% = 1 to xmod%
    for z = 1 to 12 - sc% / 2
      xmin% = (sc% - 1) * 32
      xmax% = sc% * 32 - 1
      if sc% = 1 then xmin% = xmin% + 5
      if sc% = xmod% then xmax% = xmax% - 5
      do
        x = int(rnd*(xmax%-xmin%)) + xmin% + 1
        y = int(rnd*(ubound(Level, 2)-10)) + 4
      loop until Level(x, y) = 0
      Level(x, y) = 42
    next
  next
else
  if clocks% > 0 then
  FOR z = 1 TO clocks%
   DO
     x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
     y = INT(RND * (UBOUND(Level, 2) - 15)) + 5
   LOOP UNTIL Level(x, y) = 0
   Level(x, y) = 42
  NEXT
  end if
end if

'Set some Jump Boosters
if jumps% > 0 then
FOR z = 1 TO jumps%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 10)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 32
NEXT
end if

'Set some 100 Point Bonuses
FOR z = 1 TO pbag100%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 10)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 36
NEXT

'Set some 200 Point Bonuses
FOR z = 1 TO pbag200%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 10)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 37
NEXT

'Set some 300 Point Bonuses
FOR z = 1 TO pbag300%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 10)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 38
NEXT

'Set some 400 Point Bonuses
FOR z = 1 TO pbag400%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 10)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 39
NEXT

'Set a 500 Point Bonus
for z = 1 to pbag500%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 10)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 40
next

'Set some x2 Bonuses
FOR z = 1 TO times2%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 12)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 41
NEXT

'Set some Speed Boosters
if speeds% > 0 then
FOR z = 1 TO speeds%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 10)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 33
NEXT
end if

'Set some Laser Boosters
FOR z = 1 TO lasers%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 10)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 34
NEXT

'Set some Translucencies
FOR z = 1 TO transb%
DO
  x = INT(RND * (UBOUND(Level, 1) - 15)) + 10
  y = INT(RND * (UBOUND(Level, 2) - 10)) + 5
LOOP UNTIL Level(x, y) = 0
Level(x, y) = 35
NEXT

Level(UBOUND(Level, 1) - 3, UBOUND(Level, 2) - 2) = 1
FOR x = 3 TO 5:  Level(UBOUND(Level, 1) - 3, UBOUND(Level, 2) - x) = 2: NEXT
Level(UBOUND(Level, 1) - 3, UBOUND(Level, 2) - 6) = 3

Level(player.x, player.y) = 0
  
end sub

'-----------------------------------------------------------------
'Load the high score tables

sub LoadScores(filename$)
  
OPEN datadir + filename$ FOR INPUT AS #1
FOR x = 1 TO 10
  INPUT #1, scoretable.classic(x).name
  INPUT #1, scoretable.classic(x).score
NEXT
FOR x = 1 TO 10
  INPUT #1, scoretable.onescreen(x).name
  INPUT #1, scoretable.onescreen(x).score
NEXT
FOR x = 1 TO 10
  INPUT #1, scoretable.keepitup(x).name
  INPUT #1, scoretable.keepitup(x).score
NEXT
FOR x = 1 TO 10
  INPUT #1, scoretable.timeattack(x).name
  INPUT #1, scoretable.timeattack(x).score
NEXT
FOR x = 1 TO 10
  INPUT #1, scoretable.marathon(x).name
  INPUT #1, scoretable.marathon(x).score
NEXT
CLOSE #1

end sub

'-----------------------------------------------------------------
'Load the player settings.

sub LoadSettings()
  
speeddiff = false
fullscreen = true
cheatmode = false

open datadir + "settings.ini" for input as #1
do
  line input #1, temp$
  if left$(temp$, 3) = "SPD" then
    gamespeed = val(mid$(temp$, 5))
    if gamespeed < 1 then speeddiff = true
  end if
  if left$(temp$, 3) = "FSN" then fullscreen = val(mid$(temp$, 5))
  if left$(temp$, 3) = "CHT" then 
    'Cheat code removed to prevent hacking.
  end if
loop until eof(1)
close #1

end sub

'-----------------------------------------------------------------
'Play the same game again?

function PlayAgain%()

PlayAgain% = false

cls
color white
if player.gametype = game_marathon and player.onlevel = 8 and player.completed = true and player.totalpoints >= 250000 and cheatmode = false then
  cheatmode = true
  SaveSettings
  print "You have unlocked cheat mode!": print ""
  print "Toggling cheat mode on enables:": print ""
  print "-Unending translucent in Classic"
  print "-Start with x4 in OneScreen"
  print "-Use space to move forward in KeepItUp"
  print "-Time left bonus greater in TimeAttack"
  print "-Drop in bonus x4 in Marathon"
  print ""
end if
  
if player.gametype = speed_test then
  print "Speed test results:": print ""
  print " Optimum- 37 left on the clock"
  print " 2nd Best- 35-36 left on the clock"
  print " You- " + str$(player.time) + " left on the clock"
  print ""
  if player.time <> 37 then
    print "Your speed is not optimum."
    print "This will adversely affect gameplay."
    print ""
    print "To test again with adjusted speed,"
    print "  press space."
  else
    print "You should play just fine!"
    print ""
    print "To run the test again, press space."
  end if
  print "To return to the menu, press escape."
else
  print "To play again, press space."
  print "To return to the menu, press escape."
end if

screencopy
do
  if MultiKey(SC_ESCAPE) then: while MultiKey(SC_ESCAPE): wend: exit function
loop until MultiKey(SC_SPACE)
while MultiKey(SC_SPACE): wend

if player.gametype = speed_test and player.time <> 37 then
  cls
  print "Speed Adjustment": print ""
  print "This is a multiplier for the in game"
  print "clocks.  1 is normal, lower than that"
  print "will cause the game to go faster while"
  print "higher will slow it down.": print ""
  print "Adjust speed with the up/down arrows."
  print "Hit space when finished.": print ""
  print " Current speed multiplier: " + left$(str$(gamespeed), 4)
  screencopy
  do
    if MultiKey(SC_UP) and gamespeed < 1.5 then 
      while MultiKey(SC_UP): wend
      gamespeed = gamespeed + .01
      locate 11, 28: print left$(str$(gamespeed), 4) + "  "
      screencopy
    end if
    if MultiKey(SC_DOWN) and gamespeed > .5 then 
      while MultiKey(SC_DOWN): wend
      gamespeed = gamespeed - .01
      locate 11, 28: print left$(str$(gamespeed), 4) + "  "
      screencopy
    end if
  loop until MultiKey(SC_SPACE)
  while MultiKey(SC_SPACE):wend
  if gamespeed < 1 then speeddiff = true
end if

if gamespeed <> 1 then SaveSettings

PlayAgain% = true

end function

'-----------------------------------------------------------------
'Handles a Marathon game.

sub MarathonGame ()

dim ptimer as double
do
  player.onlevel = 1
  player.lives = 3
  player.credits = 0
  player.totalpoints = 0
  player.died = false
  player.completed = false
  doscores% = false
  do
    if player.completed = true then
      player.onlevel = player.onlevel + 1
      player.completed = false
    end if
    player.points = 0
    player.startpoints = 0
    Introduce player.onlevel
    LevelInit
    GameLoop
    if player.lives = -1 then pagain% = PlayAgain%: exit do
    if player.lives = 0 then
      player.time = 0
      RenderScreen
      line (75,50)-(245,142), grey1, b
      line (76,51)-(244,141), grey2, b
      line (77,52)-(243,140), 0, bf
      if player.credits > 0 then
        contin% = UseCredit%
        line (75,50)-(245,142), grey1, b
        line (76,51)-(244,141), grey2, b
        line (77,52)-(243,140), 0, bf
        if contin% = false then locate 8, 12: print "Back to training..": screencopy
      else
        locate 8, 13: print "Out of credits.."                                    
        contin% = false
      end if
      if contin% = false then 
        locate 10, 12: print "It was a good run:"
        screencopy
        ptimer = timer: do: loop until timer - ptimer >= .5
        locate 12, 12: print "Previous: " + str$(player.totalpoints)
        ptimer = timer: do: loop until timer - ptimer >= .5
        screencopy
        ptimer = timer: do: loop until timer - ptimer >= .5
        locate 14, 15: print "Score:+" + str$(player.points)
        screencopy
        ptimer = timer: do: loop until timer - ptimer >= .5
        player.totalpoints = player.totalpoints + player.points
        locate 16, 15: print "Total: " + str$(player.totalpoints)
        screencopy
        do: loop until MultiKey(SC_SPACE)
        while MultiKey(SC_SPACE): wend
        doscores% = true
        exit do
      end if
      player.lives = 3
      player.credits = player.credits - 1
      player.totalpoints = player.totalpoints * .75
    end if
    if player.onlevel = 8 then doscores% = true
  loop until player.onlevel = 8 and player.completed = true
  if doscores% = true then
    x = 0
    DO
      x = x + 1
      IF player.totalpoints > scoretable.marathon(x).score THEN
        line (75,50)-(245,142), grey1, b
        line (76,51)-(244,141), grey2, b
        line (77,52)-(243,140), 0, bf
        color white
        locate 8, 14: print "New High Score!" 
        locate 10, 19: print str$(player.totalpoints)
        locate 12, 14: print "Name: "
        screencopy
        pname$ = GetName$(20, 12)
        if pname$ = "" then pname$ = "YourMom"
        IF x < 10 THEN
          FOR z = 9 TO x STEP -1
            scoretable.marathon(z + 1).name = scoretable.marathon(z).name
            scoretable.marathon(z + 1).score = scoretable.marathon(z).score
          NEXT
        END IF
        scoretable.marathon(x).name = pname$
        scoretable.marathon(x).score = player.totalpoints
        EXIT DO
      END IF
    LOOP UNTIL x = 10
    cls
    PrintScores player.gametype
    screencopy
    SaveScores
    do: loop until MultiKey(SC_SPACE)
    while MultiKey(SC_SPACE): wend
    pagain% = PlayAgain%
  end if
loop until pagain% = false
  
end sub

'-----------------------------------------------------------------
'Prints the high scores; gtype 1 for classic, 2 for one screen.

sub PrintScores (gtype%)

SELECT CASE gtype%
  CASE game_classic
    print "Classic High Scores"
    FOR y = 1 TO 10
      locate y + 2, 1: print scoretable.classic(y).name
      locate y + 2, 10: print LTRIM$(STR$(scoretable.classic(y).score))
    NEXT
  CASE game_onescreen
    print "One Screen High Scores"
    FOR y = 1 TO 10
      locate y + 2, 1: print scoretable.onescreen(y).name
      locate y + 2, 10: print LTRIM$(STR$(scoretable.onescreen(y).score))
    NEXT
  case game_keepitup
    print "Keep It Up High Scores"
    FOR y = 1 TO 10
      locate y + 2, 1: print scoretable.keepitup(y).name
      locate y + 2, 10: print LTRIM$(STR$(scoretable.keepitup(y).score))
    NEXT
  case game_timeattack
    print "Time Attack High Scores"
    FOR y = 1 TO 10
      locate y + 2, 1: print scoretable.timeattack(y).name
      locate y + 2, 10: print LTRIM$(STR$(scoretable.timeattack(y).score))
    NEXT
  case game_marathon
    print "Marathon High Scores"
    FOR y = 1 TO 10
      locate y + 2, 1: print scoretable.marathon(y).name
      locate y + 2, 10: print LTRIM$(STR$(scoretable.marathon(y).score))
    NEXT
END SELECT

end sub

'-----------------------------------------------------------------
'Renders our screen...

sub RenderScreen()

put (0, 0), bground, pset
line (0, 189)-(319, 199), 0, bf

FOR x = 0 TO 32
FOR y = 0 TO 19
  tx% = (x * 10) - map.offx
  ty% = (y * 10) - map.offy
  SELECT CASE Level(map.x + x, map.y + y)
    CASE 1
      put (tx%, ty%), pole1, trans
    CASE 2
      put (tx%, ty%), pole2, trans
    CASE 3
      put (tx%, ty%), pole3, trans
    case 11
      put (tx%, ty%), lbank, trans
    case 12
      put (tx%, ty%), water, trans
    case 13
      put (tx%, ty%), rbank, trans
    CASE 20
      put (tx%, ty%), ptimes2, trans
    CASE 21
      put (tx%, ty%), p100, trans
    CASE 22
      put (tx%, ty%), p200, trans
    CASE 23
      put (tx%, ty%), p300, trans
    CASE 24
      put (tx%, ty%), p400, trans
    CASE 25
      put (tx%, ty%), p500, trans
    CASE 30
      put (tx%, ty%), credit, trans
    CASE 31
      put (tx%, ty%), oneup, trans
    CASE 32
      put (tx%, ty%), jboost, trans
    CASE 33
      put (tx%, ty%), sboost, trans
    CASE 34
      put (tx%, ty%), lboost, trans
    CASE 35
      put (tx%, ty%), trans, trans
    CASE 36 TO 40
      put (tx%, ty%), points, trans
    CASE 41
      put (tx%, ty%), ptimes2, trans
    CASE 42
      put (tx%, ty%), clock, trans
    CASE 51
      put (tx%, ty%), ground, pset
    CASE 52
      put (tx%, ty%), brick, trans
    CASE 71
      put (tx%, ty%), wanim1, trans
    CASE 72
      put (tx%, ty%), wanim2, trans
    CASE 73
      put (tx%, ty%), wanim3, trans
    CASE 74
      put (tx%, ty%), wanim4, trans
  END SELECT
NEXT
NEXT

temp$ = ""
select case player.gametype
  case speed_test
    temp$ = "Speed Test"
  case game_classic
    temp$ = "Classic"
  case game_onescreen
    temp$ = "One Screen"
  case game_keepitup
    temp$ = "Keep It Up"
  case game_timeattack
    temp$ = "Time Attack"
  case game_marathon
    temp$ = "Stage: " + STR$(player.onlevel)
end select
locate 25, 1: print temp$;

'Handles the Jump/Laser Meter
line (110, 190)-(210, 199), bar1, bf
IF player.jlength > 0 THEN line (110, 190)-(110 + player.jlength * 4, 199), bar3, bf
IF player.llength > 0 THEN line (110, 195 - (player.llength / 12))-(110 + player.llength * 2, 194 + (player.llength / 12)), laser1, bf
IF player.llength = maxllength THEN line (110, 190)-(110 + player.jlength * 4, 199), laser2, bf
FOR x = 130 TO 190 STEP 20: line (x, 190)-(x, 199), bar2: NEXT
IF player.translucent > 0 THEN
  line (110, 194)-(110 + player.translucent * 5, 194), white
  line (110, 195)-(110 + player.translucent * 5, 195), grey2
END IF
IF player.pointmod >= 2 THEN line (110, 190)-(210, 199), white, b

'Handles the Start/Finish Line
line (220, 190)-(320, 199), 0, bf
put (220, 190), sfline1, trans
FOR x = 10 TO 80 STEP 10: put (220 + x, 190), sfline2, trans: NEXT
put (310, 190), sfline3, trans
x = ((map.x + player.x + 1) / (UBOUND(Level, 1) - 1)) * 90
'IF map.x = UBOUND(Level, 1) - 32 THEN x = x + 1
put (220 + x, 190), sflineb, trans

'Player sprite
plx% = (player.x * 10) + player.offx
ply% = (player.y * 10) + player.offy
SELECT CASE player.frame
  CASE 1
    put (plx%, ply%), ball1, trans
  CASE 2
    put (plx%, ply%), ball2, trans
  CASE 3
    put (plx%, ply%), ball3, trans
  CASE 4
    put (plx%, ply%), ball2, trans
  CASE 5
    put (plx%, ply%), ball1, trans
  CASE 6
    put (plx%, ply%), ball4, trans
  CASE 7
    put (plx%, ply%), ball5, trans
  CASE 8
    put (plx%, ply%), ball4, trans
END SELECT

'Handles the Score Box
tlx% = 212: tly% = 3
brx% = 309: bry% = 35

line (tlx%, tly%)-(brx%, bry%), grey1, b
line (tlx% + 1, tly% + 1)-(brx% - 1, bry% - 1), grey2, b
line (tlx% + 2, tly% + 2)-(brx% - 2, bry% - 2), 0, bf
put (tlx% + 6, tly% + 3), ball2, trans
color white
locate 2, 30: print STR$(player.lives)
put (tlx% + 21 + LEN(STR$(player.lives)) * 10, tly% + 3), credit, trans
locate 2, 33: print STR$(player.credits)
put (tlx% + 35 + (LEN(STR$(player.lives)) + LEN(STR$(player.credits))) * 10, tly% + 3), clock, trans
if player.gametype = game_keepitup then
  locate 2, 36: print "---"
else
  locate 2, 36: print STR$(player.time)
end if
put (tlx% + 6, tly% + 19), points, trans
locate 4, 30
print STR$(player.points)
  
end sub

'-----------------------------------------------------------------
'Save the high scores

sub SaveScores()

OPEN datadir + "scores.dat" FOR OUTPUT AS #1
FOR x = 1 TO 10
  PRINT #1, scoretable.classic(x).name
  PRINT #1, scoretable.classic(x).score
NEXT
FOR x = 1 TO 10
  PRINT #1, scoretable.onescreen(x).name
  PRINT #1, scoretable.onescreen(x).score
NEXT
FOR x = 1 TO 10
  PRINT #1, scoretable.keepitup(x).name
  PRINT #1, scoretable.keepitup(x).score
NEXT
FOR x = 1 TO 10
  PRINT #1, scoretable.timeattack(x).name
  PRINT #1, scoretable.timeattack(x).score
NEXT
FOR x = 1 TO 10
  PRINT #1, scoretable.marathon(x).name
  PRINT #1, scoretable.marathon(x).score
NEXT
CLOSE #1

end sub

'-----------------------------------------------------------------
'Save the player settings.

sub SaveSettings ()

open datadir$ + "settings.ini" for output as #1
  print #1, "[Game speed multiplier: 1 = normal]"
  temp$ = "SPD " + left$(str$(gamespeed), 4)
  print #1, temp$
  print #1, ""
  print #1, "[Screen size: 1 = full  0 = windowed]"
  temp$ = "FSN " + str$(fullscreen)
  print #1, temp$
  print #1, ""
  print #1, "[Cheat code]"
  temp$ = "CHT 0"
  'Cheat code removed to prevent hacking.
  print #1, temp$
close #1
  
end sub

'-----------------------------------------------------------------
'Returns a tile's type.

function TileType% (x%, y%)

TileType% = 0

tilex% = 0
tiley% = 0

IF x% >= 10 THEN
  DO
    x% = x% - 10
    tilex% = tilex% + 1
  LOOP UNTIL x% < 10
END IF

IF y% >= 10 THEN
  DO
    y% = y% - 10
    tiley% = tiley% + 1
  LOOP UNTIL y% < 10
END IF

TileType% = Level(tilex%, tiley%)
  
end function

'-----------------------------------------------------------------
'Use a credit to continue a Marathon

function UseCredit% ()

UseCredit% = false

locate 9, 15: print "Use a credit?"
locate 11, 15: print "Y - Continue"
locate 12, 15: print "N - End Game"
screencopy

do
  if MultiKey(SC_Y) then
    while MultiKey(SC_Y): wend
    UseCredit% = true
    exit do  
  end if
  
  if MultiKey(SC_N) then
    while MultiKey(SC_N): wend
    exit do
  end if
loop

end function
